

/*

AmazonItem.prototype.asin;
AmazonItem.prototype.country;
AmazonItem.prototype.info;

AmazonItem.prototype.delegate;

*/

//var asin;
//var country;
var nodes;

//var developerToken = "0BH3E6WNG02RGXB17A02";

var accessKeyID = '0FDBF9TX7PGG8K6NXP82';

var info;

AmazonItem.prototype.nodes = getAmazonInfo();


function AmazonItem(theAsin,aCountry,xml)
{
	

	this.country = aCountry;
	this.asin = theAsin;
	//country = aCountry;
	//asin = theAsin;
	//nodes = loadNodes();	
	
	if(xml != null)
	{	
	//outputNodeNamesForNode(xml);
		this.info = xmlToArray(xml);
	}
	
		
}

AmazonItem.prototype.setDelegate = function(del)
{
	this.delegate = del;
}

AmazonItem.prototype.getASIN = function() 
{
	return this.asin;
}

AmazonItem.prototype.getPoster = function() 
{
	return info['MediumImage']['URL']['#text'];
}

AmazonItem.prototype.getCountry = function()
{
	if(getAmazonInfo()[this.country] == null)
		return "us";
	else
		return this.country;
}



AmazonItem.prototype.loadItem = function() 
{
	
	//nodes = loadNodes();	
	
	var domain = nodes[this.getCountry()]['domain_ecs'];
	var associate_id = nodes[this.getCountry()]['associates_id'];
	
	//alert("domain: " + domain);
	//alert("associate_id: " + associate_id);
	//alert("country: " + this.country);
	//alert("asin: " + this.asin);
	
	var feedURL = "http://" + domain + "/onca/xml?Service=AWSECommerceService&AWSAccessKeyId=" + accessKeyID +
	"&Operation=ItemLookup&Version=2007-01-15&AssociateTag=" + associate_id +
	"&ItemId=" + this.asin +	
	"&ResponseGroup=ItemAttributes,Images,SalesRank,Tracks,Subjects,Offers,EditorialReview";
	
	//alert(feedURL);
	
	//widget.openURL(feedURL);
		
	var _self = this;
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.open("GET", feedURL);
	xmlRequest.setRequestHeader("Cache-Control", "no-cache");
	xmlRequest.onreadystatechange = function (aEvt) 
	{
		if (xmlRequest.readyState == 4) 
		{
			//if(xmlRequest.status == 200)
			_self.xmlForItemLoaded(xmlRequest);
			//bleh.xmlLoaded(xmlRequest);
			
			
		}
	};
	
	xmlRequest.send(null);

}

// Called when an XMLHttpRequest loads a feed; works with the XMLHttpRequest setup snippet
AmazonItem.prototype.xmlForItemLoaded = function(xmlRequest) 
//function xmlForItemLoaded(xmlRequest) 
{
	if (xmlRequest.status == 200) 
	{
	
	try
	{
		
		
		xmlObj = xmlRequest.responseXML;
	
		//alert("response: " + xmlRequest.responseText);
		
	
		var itemLookupResponse = xmlObj.getElementsByTagName("ItemLookupResponse")[0];
		
		
		
		//alert(itemLookupResponse.nodeValue);
		var items = itemLookupResponse.getElementsByTagName("Items")[0];
		//alert(items.nodeValue)
		var request = items.getElementsByTagName("Request")[0];
		//alert(request);
		var item = items.getElementsByTagName("Item")[0];
		
		
		
		this.info = xmlToArray(item);//,"Item","");
		
	
		
		try
		{
			this.delegate.itemDidLoad(this);
		}
		catch(err)
		{
			alert("failed to tell delegate. " + this.delegate);
		}
		
		//loadedInfoForItem(this);//this.asin,this.info);
	}
	catch(err)
	{
		alert('failed to download item info. ' + err);
	}
		
	}
	else {
		alert("Error fetching data: HTTP status " + xmlRequest.status);
	}
}



AmazonItem.prototype.createItemValueRow = function(id,value,prefix,suffix) 
{				
	var row = document.createElement('tr');
	
	
	row.setAttribute ("tag", value);
	
	if(id != null)
		row.setAttribute ("id", id);
	
	
	
	var td = document.createElement ('td');
	
	if(prefix == null)
		prefix = "";
	//else
	//	alert("prefix: " + prefix);
	if(suffix == null)
		suffix = "";
	
	td.setAttribute ("class", "itemValue");
	//alert("value: " + value);
	//td.appendChild (document.createTextNode(value));
	if(value != null)
	{
		//alert("prefix: " + prefix);
		td.innerHTML = prefix + value + suffix;
		
	}
	else
		td.innerHTML = "	";
	//td.write(value);
	//td.appendChild(document.write(value));
	row.appendChild (td);
		
	return row;
}


AmazonItem.prototype.addValue = function(container,id,value) 
{

	container.appendChild(this.createItemValueRow(id,value));
}


AmazonItem.prototype.insertValue = function(container,id,prefix,suffix) 
{

	//pairings = this.getPairings()[id];

	//path = pairings['path'];
	
	try
	{
		value = this.getValue(id);// xmlValueForPath(this.info,path);
		//alert(id + "=" + value);
	}
	catch(err)
	{
		alert("failed while traversing path: " + path);
	}

	container.appendChild(this.createItemValueRow(id,value,prefix,suffix));
	
}

AmazonItem.prototype.insertLineBreak = function(container) 
{


	

	container.appendChild(this.createItemValueRow(null,"<p></p>"));
	
}

//display the item in the container.
AmazonItem.prototype.displayItem = function(container) 
{

	removeAllChildren(container);	
	
	this.insertValue(container,'title');
	
	this.insertValue(container,'creator');
	this.insertValue(container,'author');
	this.insertValue(container,'artist');
	
	this.insertValue(container,'time',null," minutes");
	this.insertValue(container,'numberOfPages',null," pages");
	
	this.insertValue(container,'rating');
	this.insertValue(container,'aspectRatio',"Aspect Ratio: ");
	
	this.insertValue(container,'hardwarePlatform');
	this.insertValue(container,'platform');
	
	this.insertValue(container,'studio','Studio: ');
	
    //alert("dimensions: " + this.getValue("dimensions"));
	
	
	
	

	
	region = this.getValue("region");
	
	if(region != null)
	{
		img = document.createElement ('img');
		
		switch(region)
		{
			case '1':
				img.src = "Images/RegionCodes/regionOne.jpg";
				break;
			case '2':
				img.src = "Images/RegionCodes/regionTwo.jpg";
				break;
			case '3':
				img.src = "Images/RegionCodes/regionThree.jpg";
				break;
			case '4':
				img.src = "Images/RegionCodes/regionFour.jpg";
				break;
			case '5':
				img.src = "Images/RegionCodes/regionFive.jpg";
				break;
			case '6':
				img.src = "Images/RegionCodes/regionSix.jpg";
				break;
			default:
				//alert("unexpected region: " + region);
				region = null;
				break;
	
		}
		img.setAttribute("class","regionCode");
		img.setAttribute("id", "dvdRegionCode");
	
		
		if(region != null)
			container.appendChild(img);
	}
	
	//this.createItemValueRow(null,"<br>"); 
	this.insertLineBreak(container);	
	this.insertValue(container,'description');
	
	//alert("description: " + this.getValue('description'));



}

AmazonItem.prototype.getPairings = function()
{
	pairings = new Array();

	
	//pairings['actor'] (5 times)
	pairings['aspectRatio'] = ["ItemAttributes","AspectRatio"];	
	pairings['rating'] = ["ItemAttributes","AudienceRating"];
	//Binding
	pairings['director'] = ["ItemAttributes","Director"];
	pairings['creator'] = ["ItemAttributes","Creator"];
	pairings['ean'] = ["ItemAttributes","EAN"];
	
	//pairings['format'] = ["ItemAttributes","Format"]; (5 times)
	pairings['label'] = ["ItemAttributes","Label"];
	//Languages
	pairings['listPrice'] = ["ItemAttributes","ListPrice","FormattedPrice"];
	pairings['manufactuerer'] = ["ItemAttributes","Manufacturer"];
	pairings['numberOfItems'] = ["ItemAttributes","NumberOfItems"];
	//OriginalReleaseDate
	//PackageDimensions
    pairings['dimensions'] = ["ItemAttributes","PackageDimensions"];
	pairings['productGroup'] = ["ItemAttributes","ProductGroup"];
	pairings['productTypeName'] = ["ItemAttributes","ProductTypeName"];
	//Publisher
	pairings['region'] = ["ItemAttributes","RegionCode"];
	pairings['time'] = ["ItemAttributes","RunningTime"];
	pairings['studio'] = ["ItemAttributes","Studio"];
	//TheatricalReleaseDate
	pairings['title'] = ["ItemAttributes","Title"];
	pairings['UPC'] = ["ItemAttributes","UPC"];


	//books
	pairings['author'] = ["ItemAttributes","Author"];
	//Binding
	//DeweyDecimalNumber
	pairings['ean'] = ["ItemAttributes","EAN"];
	pairings['isbn'] = ["ItemAttributes","ISBN"];
	pairings['label'] = ["ItemAttributes","Label"];
	pairings['listPrice'] = ["ItemAttributes","ListPrice","FormattedPrice"];
	//Manugacturer
	pairings['numberOfItems'] = ["ItemAttributes","NumberOfItems"];
	pairings['numberOfPages'] = ["ItemAttributes","NumberOfPages"];
	//PackageDimensions
	pairings['productGroup'] = ["ItemAttributes","ProductGroup"];
	pairings['productTypeName'] = ["ItemAttributes","ProductTypeName"];
	//PublicationDate
	//Publisher
	//ReleaseDate
	pairings['studio'] = ["ItemAttributes","Studio"];
	pairings['title'] = ["ItemAttributes","Title"];


	//music
	pairings['artist'] = ["ItemAttributes","Artist"];
	//Binding
	pairings['ean'] = ["ItemAttributes","EAN"];
	pairings['label'] = ["ItemAttributes","Label"];
	pairings['listPrice'] = ["ItemAttributes","ListPrice","FormattedPrice"];
	//Manufacturer
	//MPN
	pairings['numberOfDiscs'] = ["ItemAttributes","NumberOfDiscs"];
	//OriginalReleaseDate
	//PackageDimensions
  
	pairings['productGroup'] = ["ItemAttributes","ProductGroup"];
	pairings['productTypeName'] = ["ItemAttributes","ProductTypeName"];
	//Publisher
	//ReleaseDate
	pairings['studio'] = ["ItemAttributes","Studio"];
	pairings['title'] = ["ItemAttributes","Title"];
	pairings['UPC'] = ["ItemAttributes","UPC"];


	//games
	//BatteriesIncluded
	//Binding
	pairings['ean'] = ["ItemAttributes","EAN"];
	pairings['esrbAgeRating'] = ["ItemAttributes","ESRBAgeRating"];//ESRBAgeRating
	//Feature (6 times)
	//Format
	pairings['Genre'] = ["ItemAttributes","Genre"];
	pairings['hardwarePlatform'] = ["ItemAttributes","HardwarePlatform"];
	//ItemDimensions
	pairings['label'] = ["ItemAttributes","Label"];
	pairings['listPrice'] = ["ItemAttributes","ListPrice","FormattedPrice"];
	//Manufacturer
	//MPN
	//PackageDimensions
	pairings['platform'] = ["ItemAttributes","Platform"];
	pairings['productGroup'] = ["ItemAttributes","ProductGroup"];
	pairings['productTypeName'] = ["ItemAttributes","ProductTypeName"];
	//Publisher
	//ReleaseDate
	pairings['studio'] = ["ItemAttributes","Studio"];
	pairings['title'] = ["ItemAttributes","Title"];
	pairings['UPC'] = ["ItemAttributes","UPC"];


    
	pairings['amazonPrice'] = ["Offers","Offer","OfferListing","Price","FormattedPrice"];
	pairings['amazonAvailability'] = ["Offers","Offer","OfferListing","Availability"];
	pairings['superSavingShipping'] = ["Offers","Offer","OfferListing","IsEligibleForSuperSaverShipping"];
	
	pairings['mediumImageURL'] = ["MediumImage","URL"];
	pairings['mediumImageHeight'] = ["MediumImage","Height"];
	pairings['mediumImageWidth'] = ["MediumImage","Width"];
	pairings['detailPageURL'] = ["DetailPageURL"];
	pairings['asin'] = ["ASIN"];
	
	pairings['description'] = ["EditorialReviews","EditorialReview","Content"];
	
	
	
	return pairings;

}

AmazonItem.prototype.getValue = function(name)
{
	try
	{
		return xmlValueInArrayForPath(this.info,this.getPairings()[name]);//['path']);
	}
	catch(err) 
	{
		
		alert("getValue(" +name + ") failed: " + err);
	}

}

AmazonItem.prototype.displayAmazonPriceInElement = function(element,label)
{
   
    element.innerHTML =  this.getValue('amazonPrice');
	label.innerHTML = "Amazon Price:";
    if(element.innerHTML == "undefined")
    {
        element.innerHTML = "Out of Stock";
        label.innerHTML = "";
    }
    

}


AmazonItem.prototype.displayListPriceInElement = function(element,label) 
{
	element.innerHTML =  this.getValue('listPrice');
    label.innerHTML = "List Price:";
}


AmazonItem.prototype.displayImageInElement = function(poster) 
{
	poster.src = null;
	poster.onclick = null;
	
	poster.removeAttribute("src");
	
	//pairings = this.getPairings();
	
	
	
	try
	{
	
		poster.src = this.getValue('mediumImageURL');

		ratio = this.getValue('mediumImageHeight') / this.getValue('mediumImageWidth');

		//ratio = xmlValueForPath(this.info,pairings['mediumImageHeight']['path']) / xmlValueForPath(this.info,pairings['mediumImageWidth']['path']);
		
		var posterSize = getElementSize(poster);
		//alert("poster height: " + posterSize['height']);
		
		var tolerance = 20;
		//respect the actual ratio, within tolerance (e.g., dvd cases should all be the same, a blu-ray and dvd will not).
		if(93*ratio >= 130)
			poster.style.height = "130px";
		else if(posterSize['height'] < (93*ratio-tolerance) ||
				posterSize['height'] > (93*ratio+tolerance))
		{
			
			poster.style.height = 93*ratio + "px";
		}
		
		
		var _self = this;
		var onClickHandler = function() { _self.openAmazonDetailsPage(); };
		
		
		
		//poster.setAttribute("src",this.getValue('mediumImageURL'));
		//element = poster;
		//url = this.getValue('mediumImageURL')
		//setTimeout("element.setAttribute('src',url);",100);
	
		poster.onclick = onClickHandler;
		
	}
	catch(err)
	{
		alert(err);
	}

}


AmazonItem.prototype.openAmazonDetailsPage = function(poster) 
{
	try
	{
		url = this.getValue('detailPageURL');//
		
		
		widget.openURL(url);
	}
	catch(err)
	{
		alert("fail to in open amazon details page: " + err);
	
	}
}




